DCMTK: DiOverlayImage Class Reference

DCMTK Version 3.6.9 OFFIS DICOM Toolkit

Loading...
Searching...
No Matches
Public Member Functions | List of all members
DiOverlayImage Class Reference

Class for standalone overlay images. More...

Inheritance diagram for DiOverlayImage:

## Public Member Functions
| DiOverlayImage (const DiDocument *docu, const EI_Status status)
| constructor
virtual | ~DiOverlayImage ()
| destructor
Public Member Functions inherited from DiMono2Image
| DiMono2Image (const DiDocument *docu, const EI_Status status)
| constructor
| DiMono2Image (const DiDocument *docu, const EI_Status status, const double slope, const double intercept)
| constructor, modality (linear)
| DiMono2Image (const DiDocument *docu, const EI_Status status, const DcmUnsignedShort &data, const DcmUnsignedShort &descriptor, const DcmLongString *explanation)
| constructor, modality (LUT)
| DiMono2Image (const DiColorImage *image, const double red, const double green, const double blue)
| constructor, convert color images to monochrome
| DiMono2Image (const DiMonoImage *image, DiMonoOutputPixel *pixel, const unsigned long frame, const int stored, const int alloc)
| constructor, createMonoOutput
virtual | ~DiMono2Image ()
| destructor
virtual EP_Interpretation | getInternalColorModel () const
| get color model of internal pixel representation.
virtual const void * | getOutputData (const unsigned long frame, const int bits, const int planar=0)
| get pixel data with specified format.
virtual int | getOutputData (void *buffer, const unsigned long size, const unsigned long frame, const int bits, const int planar=0)
| get pixel data with specified format.
DiImage * | createImage (const unsigned long fstart, const unsigned long fcount) const
| create copy of current image object
DiImage * | createScale (const signed long left_pos, const signed long top_pos, const unsigned long clip_width, const unsigned long clip_height, const unsigned long scale_width, const unsigned long scale_height, const int interpolate, const int aspect, const Uint16 pvalue) const
| create scaled copy of specified (clipping) area of the current image object.
DiImage * | createFlip (const int horz, const int vert) const
| create a flipped copy of the current image
DiImage * | createRotate (const int degree) const
| create a rotated copy of the current image.
DiImage * | createMono (const double dummy1, const double dummy2, const double dummy3) const
| create monochrome copy of the current image.
Public Member Functions inherited from DiMonoImage
| DiMonoImage (const DiDocument *docu, const EI_Status status)
| constructor
| DiMonoImage (const DiDocument *docu, const EI_Status status, const double slope, const double intercept)
| constructor, rescale
| DiMonoImage (const DiDocument *docu, const EI_Status status, const DcmUnsignedShort &data, const DcmUnsignedShort &descriptor, const DcmLongString *explanation)
| constructor, modality LUT
virtual | ~DiMonoImage ()
| destructor
virtual int | processNextFrames (const unsigned long fcount)
| process next couple of frames
int | getMinMaxValues (double &min, double &max, const int mode) const
| get minimum and maximum pixel values.
DiDisplayFunction * | getDisplayFunction () const
| get display function
int | setDisplayFunction (DiDisplayFunction *display)
| set display function
int | setNoDisplayFunction ()
| set no display function.
int | setNoVoiTransformation ()
| unset all VOI transformations (windows and LUTs).
int | deleteDisplayLUT (const int bits)
| delete specified display LUT(s)
int | isValueUnused (const unsigned long value)
| check whether given output value is unused
int | convertPValueToDDL (const Uint16 pvalue, Uint16 &ddl, const int bits)
| convert P-value to DDL.
int | setMinMaxWindow (const int idx=1)
| set automatically calculated minimum/maximum window.
int | setRoiWindow (const unsigned long left_pos, const unsigned long top_pos, const unsigned long width, const unsigned long height, const unsigned long frame)
| set automatically calculated VOI window for the specified Region of Interest (ROI).
int | setHistogramWindow (const double thresh)
| set automatically calculated histogram window.
int | setWindow (const unsigned long pos=0)
| set specified window (given by index to window width/center sequence stored in image file).
int | setWindow (const double center, const double width, const char *explanation=NULL)
| set specified window (given by window width and center).
int | getWindow (double &center, double &width)
| get current window center and width values
unsigned long | getWindowCount () const
| get number of VOI windows (stored in image file)
EF_VoiLutFunction | getVoiLutFunction () const
| get VOI LUT function.
int | setVoiLutFunction (const EF_VoiLutFunction function)
| set VOI LUT function
int | setVoiLut (const DcmUnsignedShort &data, const DcmUnsignedShort &descriptor, const DcmLongString *explanation, const EL_BitsPerTableEntry descripMode=ELM_UseValue)
| set VOI LUT (given by dcmdata elements).
int | setVoiLut (const unsigned long pos, const EL_BitsPerTableEntry descripMode=ELM_UseValue)
| set VOI LUT (given by index to VOI LUT sequence stored in image file).
unsigned long | getVoiLutCount () const
| get number of VOI LUTs (stored in image file)
const char * | getVoiTransformationExplanation () const
| get description of active VOI transformation
const char * | getVoiWindowExplanation (const unsigned long pos, OFString &explanation) const
| get description of specified VOI window (stored in the image file)
const char * | getVoiLutExplanation (const unsigned long pos, OFString &explanation) const
| get description of specified VOI LUT (stored in the image file)
const char * | getModalityLutExplanation () const
| get description of performed modality LUT transformation
int | setHardcopyParameters (const unsigned int min, const unsigned int max, const unsigned int reflect, const unsigned int illumin)
| set hardcopy parameters.
ES_PresentationLut | getPresentationLutShape () const
| get shape for presentation transformation.
int | setPresentationLutShape (const ES_PresentationLut shape)
| set shape for presentation transformation.
int | setPresentationLut (const DcmUnsignedShort &data, const DcmUnsignedShort &descriptor, const DcmLongString *explanation=NULL, const EL_BitsPerTableEntry descripMode=ELM_UseValue)
| set LUT for presentation transformation.
int | setInversePresentationLut (const DcmUnsignedShort &data, const DcmUnsignedShort &descriptor, const EL_BitsPerTableEntry descripMode=ELM_UseValue)
| set inverse LUT for presentation transformation.
const char * | getPresentationLutExplanation () const
| get description of active presentation LUT
int | addOverlay (const unsigned int group, const signed int left_pos, const signed int top_pos, const unsigned int columns, const unsigned int rows, const DcmOverlayData &data, const DcmLongString &label, const DcmLongString &description, const EM_Overlay mode)
| add specified plane to group of additional overlay planes.
int | removeAllOverlays ()
| remove all additional overlay planes
DiOverlay * | getOverlayPtr (const unsigned int idx)
| get pointer to specified overlay managing object
DiMonoImage * | getMonoImagePtr ()
| get pointer to current monochrome image (this)
int | flip (const int horz, const int vert)
| flip current image (horizontally and/or vertically)
int | rotate (const int degree)
| rotate current image (by steps of 90 degrees)
virtual int | getBits (const int bits=0) const
| get number of bits per sample.
virtual unsigned long | getOutputDataSize (const int bits=0) const
| get number of bytes required for the rendered output of a single frame
const void * | getOutputPlane (const int dummy) const
| get pixel data of specified plane.
void | deleteOutputData ()
| delete internally handled output memory buffer Save memory if data is no longer needed.
const void * | getOverlayData (const unsigned long frame, const unsigned int plane, unsigned int &left_pos, unsigned int &top_pos, unsigned int &width, unsigned int &height, EM_Overlay &mode, const unsigned int idx, const int bits=8, const Uint16 fore=0xff, const Uint16 back=0x0)
| create bitmap for specified overlay plane.
const void * | getFullOverlayData (const unsigned long frame, const unsigned int plane, unsigned int &width, unsigned int &height, const unsigned int idx, const int bits=8, const Uint16 fore=0xff, const Uint16 back=0x0)
| create bitmap for specified overlay plane.
void | deleteOverlayData ()
| delete buffer for overlay plane data.
unsigned long | create6xxx3000OverlayData (Uint8 *&buffer, const unsigned int plane, unsigned int &width, unsigned int &height, unsigned long &frames, const unsigned int idx=0)
| create bitmap for specified overlay plane and store it in (6xxx,3000) format.
const DiPixel * | getInterData () const
| get pointer to intermediate pixel data representation
const DiMonoPixel * | getMonoInterData () const
| get pointer to intermediate pixel data representation
unsigned long | createDIB (void *&data, const unsigned long size, const unsigned long frame, const int bits, const int upsideDown, const int padding=1)
| create true color (24/32 bit) or palette (8 bit) bitmap for MS Windows.
unsigned long | createAWTBitmap (void *&data, const unsigned long frame, const int bits)
| create true color (32 bit) or palette (8 bit) bitmap for Java (AWT default format).
DiImage * | createOutputImage (const unsigned long frame, const int bits)
| create new single frame DiImage with applied grayscale transformations.
int | writeImageToDataset (DcmItem &dataset, const int mode, const int planar)
| write current image and related attributes to DICOM dataset.
int | writePPM (STD_NAMESPACE ostream &stream, const unsigned long frame, const int bits)
| write pixel data to PPM file.
int | writePPM (FILE *stream, const unsigned long frame, const int bits)
| write pixel data to PPM file.
int | writeRawPPM (FILE *stream, const unsigned long frame, const int bits)
| write pixel data to raw PPM file
int | writeBMP (FILE *stream, const unsigned long frame, const int bits)
| write pixel data to BMP file
Public Member Functions inherited from DiImage
| DiImage (const DiDocument *docu, const EI_Status status, const int spp)
| constructor
virtual | ~DiImage ()
| destructor
EI_Status | getStatus () const
| get status of the image object
Uint32 | getNumberOfFrames () const
| get number of frames
Uint32 | getFirstFrame () const
| get index of first frame
Uint32 | getTotalNumberOfFrames () const
| get total number of frames
Uint32 | getRepresentativeFrame () const
| get representative frame
double | getFrameTime () const
| get frame time
Uint16 | getRows () const
| get number of rows
Uint16 | getColumns () const
| get number of columns
double | getPixelWidth () const
| get pixel's width
double | getPixelHeight () const
| get pixel's height
double | getRowColumnRatio () const
| get pixel's rows/column ratio
double | getColumnRowRatio () const
| get pixel's column/rows ratio
int | setRowColumnRatio (const double ratio)
| set pixel's rows/column ratio
int | setColumnRowRatio (const double ratio)
| set pixel's column/rows ratio
EP_Polarity | getPolarity () const
| get polarity.
int | setPolarity (const EP_Polarity polarity)
| set polarity.
int | writeFrameToDataset (DcmItem &dataset, const unsigned long frame=0, const int bits=0, const int planar=0)
| render pixel data of given frame and write image related attributes to DICOM dataset.

## Additional Inherited Members
Static Public Member Functions inherited from DiMonoImage
static void * | createPackedBitmap (const void *buffer, const unsigned long size, const unsigned long count, const int alloc, const int stored)
| create packed bitmap (e.g.
Protected Member Functions inherited from DiMono2Image
| DiMono2Image (const DiDocument *docu, const EI_Status status, const char dummy)
| constructor
| DiMono2Image (const DiMonoImage *image, const unsigned long fstart, const unsigned long fcount)
| constructor, copy
| DiMono2Image (const DiMonoImage *image, const signed long left_pos, const signed long top_pos, const Uint16 src_cols, const Uint16 src_rows, const Uint16 dest_cols, const Uint16 dest_rows, const int interpolate=0, const int aspect=0, const Uint16 pvalue=0)
| constructor, scale/clip
| DiMono2Image (const DiMonoImage *image, const int horz, const int vert)
| constructor, flip
| DiMono2Image (const DiMonoImage *image, const int degree)
| constructor, rotate
Protected Member Functions inherited from DiMonoImage
| DiMonoImage (const DiDocument *image, const EI_Status status, const char dummy)
| constructor
| DiMonoImage (const DiMonoImage *image, const unsigned long fstart, const unsigned long fcount)
| constructor, copy
| DiMonoImage (const DiColorImage *image, const double red, const double green, const double blue)
| constructor, convert color images to monochrome
| DiMonoImage (const DiMonoImage *image, const signed long left_pos, const signed long top_pos, const Uint16 src_cols, const Uint16 src_rows, const Uint16 dest_cols, const Uint16 dest_rows, const int interpolate, const int aspect, const Uint16 pvalue)
| constructor, scale/clip
| DiMonoImage (const DiMonoImage *image, const int horz, const int vert)
| constructor, flip
| DiMonoImage (const DiMonoImage *image, const int degree)
| constructor, rotate
| DiMonoImage (const DiMonoImage *image, DiMonoOutputPixel *pixel, const unsigned long frame, const int stored, const int alloc)
| constructor, createMonoOutput
void | Init (DiMonoModality *modality, const OFBool reuse=OFFalse)
| initialize internal data structures and member variables
void | InitUint8 (DiMonoModality *modality)
| initialize internal data structures (for Uint8)
void | InitSint8 (DiMonoModality *modality)
| initialize internal data structures (for Sint8)
void | InitUint16 (DiMonoModality *modality)
| initialize internal data structures (for Uint16)
void | InitSint16 (DiMonoModality *modality)
| initialize internal data structures (for Sint16)
void | InitUint32 (DiMonoModality *modality)
| initialize internal data structures (for Uint32)
void | InitSint32 (DiMonoModality *modality)
| initialize internal data structures (for Sint32)
int | checkInterData (const int mode=1)
| check intermediate pixel representation for consistency
virtual void | updateImagePixelModuleAttributes (DcmItem &dataset)
| update Image Pixel Module attributes in the given dataset.
const void * | getData (void *buffer, const unsigned long size, const unsigned long frame, int bits, const int planar, const int negative)
| get pixel data with specified format.
void | getDataUint8 (void *buffer, DiDisplayFunction *disp, const int samples, const unsigned long frame, const int bits, const Uint32 low, const Uint32 high)
| get pixel data with specified format for Uint8 input (helper function).
void | getDataSint8 (void *buffer, DiDisplayFunction *disp, const int samples, const unsigned long frame, const int bits, const Uint32 low, const Uint32 high)
| get pixel data with specified format for Sint8 input (helper function).
void | getDataUint16 (void *buffer, DiDisplayFunction *disp, const int samples, const unsigned long frame, const int bits, const Uint32 low, const Uint32 high)
| get pixel data with specified format for Uint16 input (helper function).
void | getDataSint16 (void *buffer, DiDisplayFunction *disp, const int samples, const unsigned long frame, const int bits, const Uint32 low, const Uint32 high)
| get pixel data with specified format for Sint16 input (helper function).
void | getDataUint32 (void *buffer, DiDisplayFunction *disp, const int samples, const unsigned long frame, const int bits, const Uint32 low, const Uint32 high)
| get pixel data with specified format for Uint32 input (helper function).
void | getDataSint32 (void *buffer, DiDisplayFunction *disp, const int samples, const unsigned long frame, const int bits, const Uint32 low, const Uint32 high)
| get pixel data with specified format for Sint32 input (helper function).
int | createLinODPresentationLut (const unsigned long count, const int bits)
| create a presentation look-up table converting the pixel data which is linear to Optical Density to DDLs of the softcopy device (used to display print images on screen).
Protected Member Functions inherited from DiImage
| DiImage (const DiDocument *docu, const EI_Status status)
| constructor
| DiImage (const DiImage *image, const unsigned long fstart, const unsigned long fcount)
| constructor, copy
| DiImage (const DiImage *image, const Uint16 width, const Uint16 height, const int aspect=0)
| constructor, scale/clip
| DiImage (const DiImage *image, const int degree=0)
| constructor, rotate
| DiImage (const DiImage *image, const unsigned long frame, const int stored, const int alloc)
| constructor, createMonoOutput
void | deleteInputData ()
| delete internally handled object for the input pixel data conversion
void | checkPixelExtension ()
| check and possibly correct values for pixel spacing, aspect ratio etc.
void | convertPixelData ()
| create input pixel data representation from DICOM dataset structures
int | detachPixelData ()
| detach pixel data.
Protected Attributes inherited from DiMonoImage
double | WindowCenter
| center of current VOI-window
double | WindowWidth
| width of current VOI-window
unsigned long | WindowCount
| number of stored VOI-windows
unsigned long | VoiLutCount
| number of stored VOU-LUTs
int | ValidWindow
| true, if current VOI-window is valid
OFString | VoiExplanation
| free text explanation of current VOI transformation
EF_VoiLutFunction | VoiLutFunction
| VOI LUT function (linear or sigmoid)
ES_PresentationLut | PresLutShape
| presentation LUT shape (identity, inverse or lin od)
unsigned int | MinDensity
| minimum density of a print-out (in hundreds of Optical Density)
unsigned int | MaxDensity
| maximum density of a print-out (ditto)
unsigned int | Reflection
| reflected ambient light (in candela per square meter)
unsigned int | Illumination
| illumination (ditto)
DiOverlay * | Overlays [2]
| points to associated overlay-objects ([0] = built-in, [1] = additional)
DiLookupTable * | VoiLutData
| points to associated VOI-LUT-object
DiLookupTable * | PresLutData
| points to associated presentation-LUT-object
DiMonoPixel * | InterData
| points to intermediate pixel data representation (object)
DiDisplayFunction * | DisplayFunction
| points to grayscale standard display function (only referenced!)
Protected Attributes inherited from DiImage
EI_Status | ImageStatus
| copy of status variable declared in class 'DicomImage'
const DiDocument * | Document
| points to special object, which encapsulates the dcmdata module
Uint32 | FirstFrame
| first frame to be processed
Uint32 | NumberOfFrames
| number of frames in case of multi-frame images (otherwise '1')
Uint32 | TotalNumberOfFrames
| total number of frames stored in the dataset
Uint32 | RepresentativeFrame
| number of representative frame, type 3 attribute (default '0')
double | FrameTime
| nominal time between individual frames (0 if absent)
Uint16 | Rows
| number of rows (in pixel)
Uint16 | Columns
| number of columns (in pixel)
double | PixelWidth
| width of each pixel according to 'PixelSpacing/AspectRatio'
double | PixelHeight
| height of each pixel according to 'PixelSpacing/AspectRatio'
Uint16 | BitsAllocated
| number of bits allocated for each pixel
Uint16 | BitsStored
| number of bits stored for each pixel (see 'BitsPerSample')
Uint16 | HighBit
| position of highest stored bit
int | BitsPerSample
| actual number of bits per sample (depth)
int | SamplesPerPixel
| number of samples per pixel (1, 3 or 4)
EP_Polarity | Polarity
| polarity (normal or reverse)
int | hasSignedRepresentation
| is 'true' if pixel data is signed
int | hasPixelSpacing
| is 'true' if attribute 'PixelSpacing' is present
int | hasImagerPixelSpacing
| is 'true' if attribute 'ImagerPixelSpacing' is present
int | hasNominalScannedPixelSpacing
| is 'true' if attribute 'hasNominalScannedPixelSpacing' is present
int | hasPixelAspectRatio
| is 'true' if attribute 'PixelAspectRatio' is present
int | isOriginal
| is 'false' if derived from original image data (e.g. scaled)
DiInputPixel * | InputData
| points to intermediate pixel representation (template object)
DcmFileCache | FileCache
| file cache object used for partial read
Uint32 | CurrentFragment
| current pixel item fragment (for encapsulated pixel data)

## Detailed Description

Class for standalone overlay images.

## Constructor & Destructor Documentation

## ◆ DiOverlayImage()

DiOverlayImage::DiOverlayImage | ( | const DiDocument * | docu,
|  | const EI_Status | status )

constructor

Parameters

  docu | pointer to dataset (encapsulated)
  status | current image status

The documentation for this class was generated from the following file:

- dcmimgle/include/dcmtk/dcmimgle/diovlimg.h

Generated on Sat Mar 1 2025 for DCMTK Version 3.6.9 by Doxygen 1.13.2